/*
 *  Classes: Members - Static Data Members  1.0 
 *
 *  Static data members are shared by all instances of a class
 */

#include <iostream>

using namespace std;

class SimpleClass
{
public:
	SimpleClass (int aValue){myValue = aValue;}
	SimpleClass () {}

	void setMyValue(int aValue) {myValue = aValue;}
	int getMyValue() {return myValue;}

	// static char myChar = 'c';   This is illegal

    static char myChar;


/*
 *  The static object is not part of the objects of the class but is
 *  shared by all instances of the class.
 *
 *  The declaration of the static variable is not a definition.
 *  The definition is required to be elsewhere.
 */
private:

		static int myValue;
};

/*
 *  Define and initialize the static variables
 */

int SimpleClass::myValue=10;
char SimpleClass::myChar = 'a';

int main( void )
{
	
	SimpleClass myClass, yourClass;

	// cout << myClass.myValue << endl;   myValue is private

	/*
	 *  myChar is public and can be accessed without an object being 
	 *  created
	 */

	cout << myClass.myChar << " " << SimpleClass::myChar << endl;

	cout << myClass.getMyValue() << " " << yourClass.getMyValue() << endl;

	return 0;
}
