/*
 *  Classes: Members 1.1 - Static Function Members
 *
 *  Static function members must be accessed through an object
 */

#include <iostream>

using namespace std;

class SimpleClass
{
public:
	SimpleClass (int aValue){myValue = aValue;}
	SimpleClass () {myNumber = 30;}

	int getMyValue() {return myValue;}
	//static int getMyNumber() {return myNumber;}  requires an object
	static int getMyNumber();
	static int getMyStuff(SimpleClass *myClass);
	static int getMyVal() {return myValue;}

	static char myChar;
	char myLetter;

private:
	static int myValue;
	int myNumber;
};

//  Define and initialize the static variables

int SimpleClass::myValue=10;
char SimpleClass::myChar = 'a';

//  Define the static functions

int SimpleClass::getMyNumber()
{
	return myValue;
}

int SimpleClass::getMyStuff (SimpleClass *aClass)
{
	//  The non static data member, myNumber, must be accessed through an
	//  object since the function has no this pointer

	return aClass->myNumber;
}

int main( void )
{
	//	Declare some class instances and a pointer
	SimpleClass myClass, yourClass, *myClassPtr;
	myClassPtr = &myClass;

	//  A static member function must access non-static members through another
	//  class instance

	cout << SimpleClass::getMyStuff(myClassPtr) << endl;

	//  A static data member can be accessed either through an access function or
	//  using a static function member which will be independent of a class

	cout << myClass.getMyNumber()<<" "
		  << SimpleClass::getMyNumber() << endl;

	//  A static data member can be accessed either through a class instance or
	//  using a static function member which will be independent of a class

	cout << myClass.myChar << " "
		  << SimpleClass::myChar << endl;

	//  Static data members are shared amongst all class instances
	cout << myClass.getMyValue() << " "
		  << yourClass.getMyVal() << endl;

    return 0;

}
