/*
 *  Classes Members - Operators 1.1
 *
 *  Operators as friends
 *
 */
#include <iostream>

using namespace std;

class Real;
class Complex;

Real operator+ (Real a1, int a2);
Complex operator+ (Real a1, Complex a2);
Complex operator+ (Complex a1, Real a2);

class Real
{
public:
	int re;
	Real (int r=0) {re = r;}

	Real operator+ (Real a1) {return Real(re + a1.re);}
};

class Complex
{
public:
	Complex(int r=0, int i=0) {re = r, im = i;}

	friend Complex operator+ (Real a1, Complex a2);
	friend Complex operator+ (Complex a1, Real a2);

	void operator++ (int) {re+=1, im+=1; cout << "postfix" << endl;}
	void operator++ () {re+=1, im+=1; cout << "prefix" << endl;}

	int getRe() {return re;}
	int getIm() {return im;}

private:
	int im, re;
};

int main( void )
{
	Real a(10), b(17), c;
	Complex d(11,25), e;

	c = b+12;
	e = a+d;
	e = d+a;

	cout << c.re << endl;
	cout << e.getRe() << " " << e.getIm() << endl;

	return 0;
}


Complex operator+ (Real a1, Complex a2)
{
	return Complex (a1.re + a2.re, a2.im);
}

Complex operator+ (Complex a1, Real a2)
{
	return Complex (a1.re + a2.re, a1.im);
}

Real operator+ (Real a1, int a2)
{
	return Real (a1.re + a2);
}