/*
 *  Classes Members - Operators 4.2
 *  Smart Pointers
 */

#include <iostream>

using namespace std;

/*
 *  Declare a class
 */

class Simple
{
public:
	Simple(int aValue = 10) {c=aValue;}

	void show() {cout << "Hi" << "  " << c << endl;}
	int c;
};

/*
 *  Declare a second class with a smart pointer
 */

class SimplePtr
{
public:
	SimplePtr(Simple* aPtr = 0) {sPtr = aPtr;}
	/*
	 *  The pointer function performs an operation then
	 *  returns a pointer to aSimpler
	 */

	Simple* operator->();
private:
	Simple *sPtr;
};

Simple* SimplePtr::operator->()
{
	//  If the pointer is NULL return a dummy, otherwise return the pointer

	static Simple nullSimpler(20);

	if (sPtr == 0)
		return &nullSimpler;
	return sPtr;
}

int main( void )
{
	SimplePtr a;					//  Declare an instance of the class SimplePtr
	a->show();                 //  User the smart pointer in class Simple
										//  to return a pointer to a Simple
	Simple b(30);
	a = &b;							//  Assign the address to the pointer a
	a->show();						//  show will display 30

	return 0;
}


