/*
 *  Classes Members - Operators 4.3
 *  Overloading the Insertion Operator
 */

#include <iostream>

using namespace std;

//  Declare a test class

class SimpleClass
{
public:
	SimpleClass(int myData=10) : aValue(myData){};

	int aValue;
};

//  Overload the insertion operator as a non-member function
//  Note we have two parameters to the function

ostream& operator <<( ostream& aStream, const SimpleClass& aClass)
{
	aStream << aClass.aValue;

	//  return the ostream object by reference
	return aStream;
}


//  Test it
void main(void)
{
	SimpleClass myClass;

	SimpleClass yourClass(19);

	//  this will pick up the overloaded operator
	//  will print 10 and 19 on execution

	cout << myClass << " " << yourClass << endl;

	return;
}
