/*
 *  Classes: Creation - Class Destructors  1.3
 *
 *	Using destructors to deinitialize memory before object deallocation
 *
 *  These are only necessary when clean up must preceed deallocation
 */

#include <iostream>

using namespace std;

class SimpleClass
{
public:
	SimpleClass (int aValue);
	SimpleClass ();

    ~SimpleClass();

	void setMyValue(int aValue) {myValue = aValue;}
	int getMyValue() {return myValue;}

private:
	int myValue;
};

/*
 *  Define the Constructors
 */

SimpleClass::SimpleClass(int aValue) : myValue(aValue)
{
	cout << "In standard constructor" << endl;
};

SimpleClass::SimpleClass() : myValue(10)
{
	cout << "In default constructor" << endl;
};

/*
 *  Define the Destructor
 *  In this program, the destructor will be called twice as the 2 instances of
 *  SimpleClass go out of scope when the function main exits
 */

 SimpleClass::~SimpleClass()
 {
	cout << "Cleaning up the mess you've made" << endl;
 }

int main( void )
{
	
	SimpleClass myClass(15), yourClass;

	myClass.setMyValue(20);

	// cout << myClass.myValue() << endl;

	cout << myClass.getMyValue() << " " << yourClass.getMyValue() << endl;

    return 0;

}
