/*
 *  Classes: Creation - Using Private Constructors 1.5
 */

#include <iostream>

using namespace std;

 /*
  *   The constructor for Date is private and thus can only be accessed
  *   by instances of the class Holiday.
  */

class Date
{
	friend class Holiday;

public:
	int getDay() {return day;}
	int getMonth() {return month;}
	int getYear() {return year;}

	void showDate();

private:
	Date (int aDay=15, int aMonth=8, int aYear=1971);
	int day;
	int month;
    int year;
};

Date::Date(int aDay, int aMonth, int aYear)
{
	day = aDay;
	month = aMonth;
    year = aYear;
};

void Date::showDate()
{
	cout << "The date is: " << day << '/'<< month << '/' << year << endl;
};

/*
 *  The class Holiday is created to show how one can limit access to a
 *  constructor.
 *
 *  Only instances of the class Holiday can create instances of the
 *  class Date.
 */

class Holiday
{
public:
	Date *createHoliday(int day, int month) {myHoliday = new Date (day, month);
											 return myHoliday;}
	void getHoliday() {myHoliday->showDate();}

private:
	Date *myHoliday;
};

int main()
{
	//  Create an instance of a Holiday then initialize it

	Holiday date1;
	date1.createHoliday(10,12);

    //  Display the Holiday
	date1.getHoliday();

    return 0;

}