/*
 *	C to C++ - inline specifier 1.0
 *
 *  Using the inline specifier to perform an inline expansion of a function
 */

#include <iostream>
#include <string>

using namespace std;

/*
 *  The function min will be expanded inline
 */

inline int min (int v1, int v2)
{
	return (v1 <= v2 ? v1 : v2);
}

struct Array
{
	Array() {size = 10;}
	Array (int aValue);			//  Implemented as a function call

	void show();				//  Implemented as an inline expansion
	int size;
};

Array::Array(int aValue)
{
	size = aValue;
}

inline void Array::show()
{
	cout << "The size is:  " << size << endl;
	return;
}
int main()
{
	int i=2, j=3;
	int minValue = min(i,j);		//  Is expanded to:
									//  int minValue  = (i <= j) ? i : j
    cout << "The min value is:  " << minValue << endl;
    
	struct Array c(3);
	struct Array b;
	cout << "C size is: " <<c.size<< endl<<"B size is: "<<b.size<< endl;
	b.show();
	return 0;
}