/*
 *	C to C++ - iostream 1.4
 *
 *  Output Formatting - Change of Base and Case for Numbers
 *
 *  Character, String, Line Input and Output
 */

#include <iostream>
#include <string>
#include <iomanip>

using namespace std;

int main()
{
	// Set case to upper for numbers
	cout.setf(ios::uppercase);

	//  character out					prints a
	cout.put('a') << endl;

	//  string out						prints My na
	char *s = "My name is";
	cout.write (s, 5) << endl;

	// change of base					prints FD
	cout.setf(ios::hex, ios::basefield);
	cout << 253 << endl;

	// Set case to lower for numbers	prints 6d 157
	cout.unsetf(ios::uppercase);
	cout << 109 << endl;

	cout.setf(ios::oct, ios::basefield);
	cout << 111 << endl;

	// input a character				prints input character
	char a;
	cin.get(a);
	cout << a << endl;

	//  input a string					puts 8 bytes of input string
	//									into buffer b.  no '\0'
	char b[80];
	cin.read(b, 8);
	b[8] = NULL;
	cout << b << endl;

	//  input a line					puts characters upto the
	//									delimiter ('|') of input line
	//									into buffer c.  adds '\0'
	char c[80];
	cin.getline(c,80, '|');
	cout << c << endl;

	return 0;
}
