#include <iostream>

using namespace std;

/*
 *  C to C++ Reference Types - Reference Types and Pointers 1.3 
 *
 *  See the ARM, pages 153-155.
 *  One cannot define pointers to references and consequently to
 *  arrays of references.  The latter is true since int & v[] will
 *  implicitly create a pointer to a reference:  v[1] -> *(v+1) thus a
 *  pointer to a reference.
 *
 *  If the reference refers to a const, (const int& myRef=10), a temporary
 *  object is created and initialized to 10.  The reference becomes a
 *  name for that object.
 *
 *  In this example, if one tries to use number as the reference, a
 *  a temporary would be created since an array is implicitly a const.
 *
 */

void get(char* &number);

int main()
{
	char number[5];
	char *numPtr = number;

	get(numPtr);

    cout << number << endl;
    return 0;
}

void get(char * &number)
{
	cout << "Enter a number" << endl;
	cin >> number;
	return;
}
