/*
 *
 *   C++ Exceptions - Exception Handlers 1.0
 *
 *		A Simple Exception Handler for Divide By Zero Errors
 *
 */
#include <iostream>

using namespace std;

float quotient(int num1, int num2);

//  Define the exception class
class DivideByZeroError
{
public:

	DivideByZeroError() : message("OOPs gotta Problem!!!!"), val(5) { }
	DivideByZeroError(int aValue) : message("OOPs gotta Problem!!!!"), val(aValue) { };
	void printMessage() {cout << message << endl;}
	void printVal() {cout << val << endl;}

private:
	char* message;
	int val;
};

int main()
{
	int num1, num2;

	cout << "Enter two ints:  ";
	cin >> num1 >> num2;

	//  Code that may throw an exception

	try
	{
		float result = quotient (num1, num2);
		cout << "The result is:   " << result << endl;
	}

	//  Catch the exception
	catch (DivideByZeroError handleError)
	{
		cout << "Error: ";

		//  Send printMessage message to handleError
		handleError.printMessage();
		handleError.printVal();
		cout << endl;

		return 1;
	}

   return 0;
}

float quotient (int num1, int num2)
{
	//  Check for divisor == 0
	//  Throw and exception if so
	if (num2 == 0)
		//  Specify the name of the constructor for the exception object
		//  The object will be caught by the catch statement specifying that
		//  type
		throw DivideByZeroError(3);

   return (float) num1 / num2;
}


