/*
 *   C++ Exceptions - Exception Handlers 1.1
 *
 *		Catching Multiple Exceptions
 */

#include <iostream>

using namespace std;

float quotient(int num1, int num2);

//  Define an exception class
class DivideByZeroError
{
public:
	DivideByZeroError() : message("OOPs gotta Problem!!!!") { }
   void printMessage() {cout << message << endl;}

private:
	char* message;
};

int main()
{
	int num1, num2;

	cout << "Enter two ints:  ";
	cin >> num1 >> num2;

	//  Code that may throw an exception
	try
	{
		float result = quotient (num1, num2);
		cout << "The result is:   " << result << endl;
	}
	/*
	 *  Specify the exception handlers
	 */

	//  Catch int type exceptions
	catch (int anInt)
   {
		cout << "Dividing by the int  " << anInt << endl;
   }
	//  Catch char type exceptions
   catch (char aChar)
   {
		cout << "Doin' the char  " << aChar << endl;
   }
	//  Catch char* type exceptions
   catch (char* aString)
   {
		cout << "I broke my guitar " << aString << endl;
	}
	//  Catch class type exceptions
   catch (DivideByZeroError error)
   {
   	cout << "Error: ";
      error.printMessage();
      cout << endl;

      return 1;
	}

   return 0;
}

float quotient (int num1, int num2)
{
	//  Throw an exception based upon the value of the numerator
	if (num2 == 0)
			throw DivideByZeroError();
	else if (num2 < 5)
		throw "Divisor too small!!!!!";

	else if (num2 > 10)
		throw 'E';

	else if (num2 == 8)
		throw num2;

	//  No eceptions - retrun the quotient
   return (float) num1 / num2;
}



