/*
 *
 *   C++ Exceptions - Exception Handlers 1.2
 *
 *		Resume Execution After an Exception
 *
 */
#include <iostream>

using namespace std;

float quotient(int num1, int num2);

//  Define an exception class
class DivideByZeroError
{
public:

	DivideByZeroError() : message("OOPs gotta Problem!!!!") { }
	void printMessage() {cout << message << endl;}

private:
	char* message;
};

int main()
{
	int num1, num2;

	cout << "Enter two ints:  ";
	cin >> num1 >> num2;

	//  Code that may throw an exception
	try
	{
		float result = quotient (num1, num2);
		cout << "The result is:   " << result << endl;
	}
	/*
	 *  Specify the exception handler
	 */

	//  Catch class type exceptions
	catch (DivideByZeroError error)
	{
		cout << "Error: ";
		error.printMessage();
		cout << endl;

		//  Execution will resume following the catch
	}

	cout << "Continuing Execution...Your Code Here" << endl;

   return 0;
}

float quotient (int num1, int num2)
{
	//  Throw an exception if the numerator is 0
	if (num2 == 0)
   		throw DivideByZeroError();

   return (float) num1 / num2;
}


