/*
 *   C++ Exceptions - Exception Handlers 1.3
 *
 *		Recovery from within an Exception Handler
 */
#include <iostream>

using namespace std;

float divideStuff();

float quotient(int num1, int num2);

//  Define an exception class
class DivideByZeroError
{
public:

	DivideByZeroError() : message("OOPs gotta Problem!!!!") { }
	void printMessage() {cout << message << endl;}

private:
	char* message;
};

int main()
{

	float result;
	
	result = divideStuff();

	cout << "Continuing Execution...Picture your code here!!!" << endl;

   return 0;
}


float divideStuff()
{
  	int num1, num2;
	float result;
	
	cout << "Enter two ints:  ";
	cin >> num1 >> num2;

	//  Code that may throw an exception
	try
	{
		result = quotient (num1, num2);
		cout << "The result is:   " << result << endl;
	}
	/*
	 *  Specify the exception handler
	 */

	//  Catch class type exceptions
	catch (DivideByZeroError error)
	{
		cout << "Error: ";
		error.printMessage();
		cout << endl;

		cout << "Get it right this time...." << endl;

		//  Attempt to recover
		//
		//  Execution will resume following the catch
		
		return divideStuff();
	}

	return result;
}

float quotient (int num1, int num2)
{
	//  Throw an exception if the numerator is 0
	if (num2 == 0)
   		throw DivideByZeroError();

   return (float) num1 / num2;
}


