/*
 *   C++ Exceptions - Exception Handlers 2.0
 *
 *		Specifying the Exceptions and Setting the Terminate Function
 */
#include <iostream>
//#include <excpt.h>
#include <eh.h>  //- microsoft header
#include <cstdlib>
#include <cstring>

using namespace std;

class except0 {};
class except1 {};
void g ();

//  Specify the the exception list

void f(int i) throw (except0, except1)
{
	switch(i)
	{
		//  Can throw a class type

		case 1:  throw except0();

		case 2:	throw except1();
	}
	g();
}

void g()
{
	//  Throw a built-in type

	throw 47;
}
//  Define the terminate function
void myTerminate()
{
	cout << "Gotcha, you're finished now!!!!!"  << endl;
   //  abort on terminate
	abort();
}

int main()
{
	//  Set the terminate function
	set_terminate (myTerminate);

	/*  Execution will print
			Caught except0 over here
			Caught except1 in here
			Gotcha, you're finished now!!!!!

         Program Aborted
	*/
	for (int i = 1; i <=3; i++)
	{
		//  Code that may throw an exception
		try
		{
			f(i);
		}
		/*
		 *  Specify the exception handlers
		 */

		//  Catch several different class type exceptions
		catch(except0)
		{
			cout << "Caught except0 over here"<< endl;
		}

		catch(except1)
		{
			cout << "Caught except1 in here"<< endl;
		}
	}

   return 0;

}

