/*
 *   C++ Exceptions - Exception Handlers 4.0
 *
 *		Dealing with Constructors and Destructors
 */
#include <iostream>
#include <excpt.h>
#include <cstdlib>
#include <cstring>

using namespace std;

//  Define a couple of classes
class Things
{
public:
	Things():myData(9){};
	~Things() {cout << "Destroying my things...don't tell mom" << endl;}

	int myData;
};

class SimpleClass
{
public:
	SimpleClass(Things aThing)throw(char*) {myThing = aThing; throw ("Help");}

	~SimpleClass() {cout << "I am the destructor" << endl;}

	Things myThing;

};


int main()
{
	//  Code that may throw an exception
	try
	{
		/*  Execution will print:
				Destroying my things...don't tell mom - From initial declaration
				Destroying my things...don't tell mom - Copy passed to constructor
				Destroying my things...don't tell mom - Copy assigned to myThing
				Help
		*/

		Things aThingy;
		SimpleClass aSimpleThing(aThingy);
	}
	catch (char* aMessage)
	{
		cout << aMessage << endl;
	}

	return 0;

}


