/*
 *   C++ Exceptions - Exception Handlers 5.0
 *
 *		Handlers and Inheritance
 */
#include <iostream>
#include <excpt.h>
#include <cstdlib>
#include <cstring>

using namespace std;

class except0 {};
class except1 : public except0 {};
void g ();
void f() throw(except1);
void myUnexpected();


int main()
{
	//  Set the unexpected handler
	set_unexpected (myUnexpected);

	/*  Execution will print
			Caught except0 over here
	*/

	//  Code that may throw an exception
	try
	{
		f();
	}

	/*
	 *  Observe:  this will be caught as except0 even though an except1 was
	 *            thrown.
     *			  This should result in a compiler warning.
	 */

	/*
	 *  Specify the exception handlers
	 */

	//  Catch several different class type exceptions
	catch(except0)
	{
		cout << "Caught except0 over here"<< endl;
	}
	catch(except1)
	{
		cout << "Caught except1 over here"<< endl;
	}

	return 0;

}

//  Specify the the exception list

void f() throw (except1)
{
	throw except1();
	g();

}

void g()
{
	//  Throw a built-in type
	throw 47;
}
//  Define the unexpected handler
void myUnexpected()
{
	cout << "Wow, what an unexpected pleasure!!!!"  << endl;
	exit(1);
}

