/*
 *  Classes Derivation - Single Inheritance 1.1
 *  
 *  Simple Inheritance - Base Class Initialization
 */
#include <iostream>

using namespace std;


class BaseClass
{
public:
	BaseClass();
	BaseClass(int aValue);
	int baseValue;
};


BaseClass::BaseClass():baseValue(20)
{
};

BaseClass::BaseClass(int aValue):baseValue(aValue)
{
};

class DerivedClass : public BaseClass
{
public:
	DerivedClass();
	DerivedClass(int aDerivedValue);
	int getDerivedValue() {return derivedValue;}
	void setDerivedValue (int aValue) {derivedValue = aValue;}

private:
	int derivedValue;
};
/*
 *  The constructor for DerivedClass is used to initialize the data member
 *  baseValue of the base class to the constant value 15.
 */

DerivedClass::DerivedClass():derivedValue(10)
{
};

DerivedClass::DerivedClass(int aValue):derivedValue(aValue), BaseClass(15)
{
};

int main( void )
{
	BaseClass base;
	DerivedClass child(5);

	cout << base.baseValue << endl;				//  will print 20
	cout << child.baseValue << endl;			//  will print 15
	cout << child.getDerivedValue() << endl;	//  will print  5
	return 0;
}
