/*
 *  Classes Derivation - Single Inheritance 3.1
 *  
 *  Simple Inheritance - Protected Members Under Derivation
 */
#include <iostream>

using namespace std;


class BaseClass
{
public:
	BaseClass();
	BaseClass(int aValue);

protected:
	int baseValue;
};  

BaseClass::BaseClass(): baseValue(0)
{
};


BaseClass::BaseClass(int aValue): baseValue(aValue)
{
};

class DerivedClass : public BaseClass
{
public:
	DerivedClass();
	//  Access BaseClass
	int getBaseValue() {return baseValue;}

	int derivedValue;
}; 

DerivedClass::DerivedClass():derivedValue(15),BaseClass(10)
{
}; 


int main( void )
{
	BaseClass base;
	DerivedClass child;

	//cout << base.baseValue << endl;		// compile error - protected

	//cout << child.baseValue << endl;		// compile error - protected 
											// member
	cout << child.getBaseValue() << endl;	// 15 - accessable by member
											//      function only
	cout << child.derivedValue << endl;		// 10 - public

	return 0;
}