/*
 *  Class Derivation - Single Inheritance 4.1
 *  
 *  Simple Inheritance - Conversion Under Derivation
 */
#include <iostream>

using namespace std;

class Fruit;

void show (Fruit aFruit);
void showRef(Fruit& aFruit);
void showPtr (Fruit* aFruit);

class Fruit
{
public:
	Fruit() {stem = 1; seeds = 4;}
	char *identify() {return "Fruit";}
	int stem;
	int seeds;
};

class Apple : public Fruit
{
public:
	Apple() {skin = 2; stem = 3;}
	char* identify() {return "Apple";}
	int skin;
	int stem;
};

int main( void )
{
	Apple a, *aPtr = &a;
	Fruit f, *fPtr = &f;

	//  will print Apple Fruit
	cout << a.identify() << "  " << f.identify() << "  " << endl;

	/*
	 *  conversions under derivation
	 */

	//  derived class object converted to a public base class object
	show(a);

	//  derived class reference converted to a public base class reference
	//  a is still an apple with a stem value of 3
	showRef(a);
	cout << a.stem << endl;							//  prints 3

	//  derived class pointer converted to public base class pointer
	showPtr(aPtr);

	// aPtr = new Fruit;							//  error,no implicit
													//  conversion 
													//  stem = 1,
													//  skin uninitialized
													//  and undefined
 
	//  explicit cast - legal but dangerous
	aPtr = (Apple *)new Fruit;					
	cout << aPtr->seeds << endl;					//  returns 4
	cout << aPtr->stem << endl;				  		//  uninitialized
	cout << aPtr->identify() << endl;				//  returns Apple

	aPtr = new Apple;
	fPtr = aPtr;
	cout << fPtr -> identify()<< endl;				//  returns Fruit
	cout << ((Apple *) fPtr)->identify()<< endl;	//  returns Apple
	cout << fPtr->stem << endl;						//  returns 1
	cout << ((Apple *) fPtr)->stem << endl;			//  returns 3

	return 0;
}

void show(Fruit aFruit)
{
	cout << aFruit.stem << endl;                	// returns 1
	cout << aFruit.identify() << endl; 				// returns Fruit
	return;
}

void showRef(Fruit& aFruit)
{
	cout << aFruit.stem << endl;					// returns 1
	aFruit.stem = 7;								// stem = 7
	cout << aFruit.identify() << endl; 				// returns Fruit
	return;
}

void showPtr(Fruit* aFruit)
{
	cout << aFruit->stem << endl;               	// returns 7 - changed
													// in showRef()
	cout << aFruit->identify() << endl; 			// returns Fruit
	return;
}