/*
 *  Classes Derivation - Single Inheritance 4.0
 *  
 *  Simple Inheritance - Overriding Function Members
 */

#include <iostream>

using namespace std;

class BaseClass
{
public:
	BaseClass();
	BaseClass(int aValue);

	void set() {value = 23;}
	void set(int aValue) {value = aValue;}
    int get() {return value;}

protected:
	int value;
};  

BaseClass::BaseClass(): value(0)
{
};


BaseClass::BaseClass(int aValue): value(aValue)
{
};
 

class DerivedClass : public BaseClass
{
public:
	DerivedClass();

	void set() {value = 16;}
	void set(int aValue) {value = aValue;}
	int get() {return value;}

private:
	int value;
};

DerivedClass::DerivedClass():value(25)
{
};

int main( void )
{
	BaseClass base;
	DerivedClass child;

	cout << child.get() << endl;				// 25  set by default
												//     constructor

	child.set();
	cout << child.get() << endl;				// 16  set by default value
												//     in set()
	child.set(40);
	cout << child.get() << endl;				// 40  set by child.set()
	cout << child.BaseClass::get() << endl;     //  0  set by default
												//     constructor

	child.BaseClass::set(15);					
	cout << child.BaseClass::get() << endl;		// 15  set by base.set()

	return 0;
}