/*
 *  Classes Derivation - Single Inheritance 1.2
 *  
 *  Simple Inheritance - Base Class Initialization
 */
#include <iostream>

using namespace std;

class BaseClass
{
public:
	BaseClass();
	BaseClass(int aValue);
	int baseValue;
};

BaseClass::BaseClass():baseValue(20)
{
};

BaseClass::BaseClass(int aValue):baseValue(aValue)
{
};

class DerivedClass : public BaseClass
{
public:
	DerivedClass();
	DerivedClass(int aDerivedValue);
    DerivedClass(int aDerivedValue, int aBaseValue);
	int getDerivedValue() {return derivedValue;}
	void setDerivedValue (int aValue) {derivedValue = aValue;}

private:
	int derivedValue;
};

/*
 *  The constructor for DerivedClass is used to initialize the data member
 *  baseValue of the base class to the constant value 15.
 */


DerivedClass::DerivedClass():derivedValue(10)
{
};

DerivedClass::DerivedClass(int aValue):derivedValue(aValue),BaseClass(15)
{
};

/*
 *  The constructor for DerivedClass is used to initialize the data member
 *  baseValue of the base class to the value of the variable aBaseValue.
 *
 *  This value is passed in as an argument of the derived class constructor
 */

DerivedClass::DerivedClass(int aValue, int aBaseValue):derivedValue(aValue),BaseClass(aBaseValue)
{
};



int main( void )
{
	BaseClass base;

	  //  5 initializes the instance of the Derived Class and 35
	  //  initializes the data member inherited fromthe base class

	DerivedClass child(5, 35);

	cout << base.baseValue << endl;				//  will print 20
	cout << child.baseValue << endl;			//  will print 35
	cout << child.getDerivedValue() << endl;	//  will print 5

	return 0;
}
