/*
 *  Classes Derivation - Multiple Inheritance 7.0
 *  
 *  Simple Inheritance - Virtual Base Class
 */
#include <iostream>

using namespace std;

class Fruit
{
public:
	Fruit() {stem = 1; seeds = 4;}
	virtual char *identify() {return "Fruit";}
    virtual char *skin () = 0;
	int stem;
	int seeds;
};

class Plum : public virtual Fruit
{
public:
	Plum() {seeds = 1; stem = 2;}
	char* identify() {return "Plum";}
	char *skin() {return "Smooth";}
};

class Peach : public virtual Fruit
{
public:
	Peach() {stem = 3;}
	char* identify() {return "Peach";}
	char *skin() {return "Fuzzy";}
};

class Nectarine : public Plum, public Peach
{
public:
	Nectarine() {};
	char* identify() {return "Nectarine";}
	char *skin() {return "Smooth";}
};

int main( void )
{
	Nectarine *np = new Nectarine;

	cout << np->identify() << endl;		//  returns Nectarine
	cout << np->skin() << endl;         //  returns smooth
	cout << np->stem << endl;           //  returns 3 - value set by Peach
	return 0;
}