/*
 *  Classes Derivation - Single Inheritance 1.3
 *  
 *  Simple Inheritance - Default Initialization
 */
#include <iostream>

using namespace std;

class BaseClass
{
public:
	BaseClass(int aValue=20);
	int baseValue;
};

BaseClass::BaseClass(int aValue): baseValue(aValue){};

class DerivedClass : public BaseClass
{
public:
	DerivedClass();
	DerivedClass(int aValue);
	int getDerivedValue() {return derivedValue;}
	void setDerivedValue (int aValue) {derivedValue = aValue;}

private:
	int derivedValue;
};

/*
 *  The constructor for DerivedClass is used to supply default values to
 *  initialize the DerivedClass and CaseClass data members.
 *
 *  Note the default constructor has no body.
 */

DerivedClass::DerivedClass() : derivedValue(15), BaseClass(10)
{
};

DerivedClass::DerivedClass(int aValue) : derivedValue(aValue), BaseClass(10)
{
};

int main( void )
{
	BaseClass base;
	DerivedClass child;

	cout << base.baseValue << endl;				//  will print 20
	cout << child.baseValue << endl;            //  will print 10
	cout << child.getDerivedValue() << endl;    //  will print 15

	return 0;
}
