/*
 *  Classes Derivation - Single Inheritance 1.4
 *  
 *  Simple Inheritance - Default Initialization
 *
 *  Inheritance / Initialization Chain
 */
#include <iostream>

using namespace std;

class BaseClass
{
public:
	BaseClass(); 
	BaseClass(int aValue); 	
	int baseValue;
};

BaseClass::BaseClass(): baseValue(0)
{
	cout << "In Base Class Default Constructor" << endl;
};


BaseClass::BaseClass(int aValue): baseValue(aValue)
{
	cout << "In Base Class Constructor" << endl;
}

/*
 *  DerivedClass1 publically inherits from BaseClass
 */

class DerivedClass1 : public BaseClass
{
public:
	DerivedClass1();
	DerivedClass1(int aValue);
	int derivedValue1;
};
 
/*
 *  DerivedClass2 publically inherits from DerivedClass1
 */

class DerivedClass2 : public DerivedClass1
{
public:
	DerivedClass2();
	DerivedClass2(int aValue);

	int derivedValue2;
};


/*
 *  Default initialization of declared and inherited data members of
 *  instances of DerivedClass1
 */

DerivedClass1::DerivedClass1() : derivedValue1(11), BaseClass(1)
{
	cout << "In Derived Class 1 Default Constructor" << endl;
};

DerivedClass1::DerivedClass1(int aValue) : derivedValue1(aValue)
{
	cout << "In Derived Class 1 Constructor" << endl;
};

/*
 *  Default initializatoin of declared and inherited data members of
 *  instances of DerivedClass2
 */

DerivedClass2::DerivedClass2() : derivedValue2(21), DerivedClass1(12)
{
	cout << "In Derived Class 2 Default Constructor" << endl;
};

DerivedClass2::DerivedClass2(int aValue) : derivedValue2(aValue)
{
	cout << "In Derived Class 2 Constructor" << endl;
};


int main( void )
{
	BaseClass base;
	DerivedClass2 child;

	cout << base.baseValue << endl;  		// 0  - Uses BaseClass
											//		Default Constructor
											 

	cout << child.baseValue << endl;        // 0  - Uses BaseClass
											//		Default Constructor
											//		through DerivedClass2
											//		Default Constructor
											//

	cout << child.derivedValue1 << endl;	// 12 - Uses DerivedClass1 C
											//		Constructor through
											//		DerivedClass2 Default
											//		Constructor
										

	cout << child.derivedValue2 << endl;	// 21 -  Uses DerivedClass2
											//		 Default Constructor

	return 0;
}
