/*
 *  Classes Derivation - Single Inheritance 1.5
 *  
 *  Simple Inheritance - Member Over riding
 */
#include <iostream>

using namespace std;

class BaseClass
{
public:
	BaseClass();

    int baseFunction() {return 15;}
	int baseValue0;
	int baseValue1;
};

BaseClass::BaseClass(): baseValue0(20), baseValue1(30)
{
};
/*
 *  Instances of Derived Class mask the return value of the inherited
 *  inherited function:  baseFunction().
 */
class DerivedClass : public BaseClass
{
public:
	DerivedClass();

	//  Mask Individual Member
	int baseFunction() {return 27;}

    //  Access DerivedClass
	int getDerivedValue() {return derivedValue;}
	void setDerivedValue (int aValue) {derivedValue = aValue;}

private:
	int derivedValue;
};

DerivedClass::DerivedClass():derivedValue(10)
{
};

int main( void )
{
	BaseClass base;
	DerivedClass child;

	cout << base.baseValue0 << endl;			//  will print 20
	cout << child.baseValue0 << endl;           //  will print 20

	cout << base.baseFunction() << endl;        //  will print 15
	cout << child.baseFunction() << endl;       //  will print 27
	cout << child.getDerivedValue() << endl;    //  will print 10

	return 0;
}