/*
 *  Classes Derivation - Single Inheritance 2.0
 *  
 *  Simple Inheritance - Private Derivation
 */
#include <iostream>

using namespace std;

class BaseClass
{
public:
	BaseClass();
	BaseClass(int aValue);
	int baseValue;
}; 

BaseClass::BaseClass(): baseValue(20)
{
};


BaseClass::BaseClass(int aValue): baseValue(aValue)
{
};
 

class DerivedClass : private BaseClass
{
public:
	DerivedClass();
	DerivedClass(int aDerivedValue);
	DerivedClass(int aDerivedValue, int aBaseValue);

	//  Access BaseClass
	int getBaseValue() {return baseValue;}
	void setBaseValue (int aValue) {baseValue = aValue;}

    //  Access DerivedClass
	int getDerivedValue() {return derivedValue;}
	void setDerivedValue (int aValue) {derivedValue = aValue;}

private:
	int derivedValue;
}; 

DerivedClass::DerivedClass():derivedValue(10)
{
};

DerivedClass::DerivedClass(int aValue):derivedValue(aValue),BaseClass(15)
{
};    

DerivedClass::DerivedClass(int aValue, int aBaseValue):derivedValue(aValue),BaseClass(aBaseValue)
{
}  ;

int main( void )
{
	BaseClass base;
	DerivedClass child(5, 35);

	cout << base.baseValue << endl;				// 20 - baseValue from
												//		BaseClass
    // cout << child.baseValue << endl;			// compile error
	cout << child.getBaseValue() << endl;		// 35 - baseValue from
    											//		DerivedClass
	cout << child.getDerivedValue() << endl;	//  5 - derivedValue

	return 0;
}