/*
 *  Classes Derivation - Single Inheritance 2.1
 *  
 *  Simple Inheritance - Private Derivation followed by Public Derivation
 */
#include <iostream>

using namespace std;

class BaseClass
{
public:
	BaseClass(); 
	BaseClass(int aValue);
	int baseValue;
};


BaseClass::BaseClass(): baseValue(0)
{
};


BaseClass::BaseClass(int aValue): baseValue(aValue)
{
	cout << "In Base Class Constructor" << endl;
}  

class DerivedClass1 : private BaseClass
{
public:
	DerivedClass1();

	//  Access BaseClass
	int getBaseValue() {return baseValue;}

	int derivedValue1;
};
DerivedClass1::DerivedClass1():derivedValue1(10)
{
};

/*
 *  baseValue is inherited privately from DerivedClass1
 */

class DerivedClass2 : public DerivedClass1
{
public:
	DerivedClass2();

	int derivedValue2;
};
DerivedClass2::DerivedClass2():derivedValue2(20)
{
};

int main( void )
{
	BaseClass base;
	DerivedClass1 child1;
	DerivedClass2 child2;

	cout << base.baseValue << endl;				//  0

	// cout << child1.baseValue << endl;		// compile error - private
												// derivation
	cout << child1.getBaseValue() << endl;		//  0
	cout << child1.derivedValue1 << endl;		// 10

	//cout << child2.baseValue << endl;			// compile error - private
												// from DC1
	cout << child2.getBaseValue() << endl;		//  0
	cout << child2.derivedValue1 << endl;		// 10 - public under
												// derivation
	cout << child2.derivedValue2 << endl;		// 20
	return 0;
}