/*
 *  Classes Derivation - Single Inheritance 2.2
 *  
 *  Simple Inheritance - Private Derivation - Exemptions from a Private
 *                       Derivation
 */
#include <iostream>

using namespace std;

class BaseClass
{
public:
	BaseClass();

    int baseFunction() {return 15;}
	int baseValue0;
	int baseValue1;
}; 


BaseClass::BaseClass(): baseValue0(20), baseValue1(30)
{
}; 

class DerivedClass : private BaseClass
{
public:
	DerivedClass();

    //  Uncover BaseClass private members 
	BaseClass::baseValue0;
	BaseClass::baseFunction;

    //  Access DerivedClass
	int getDerivedValue() {return derivedValue;}
	void setDerivedValue (int aValue) {derivedValue = aValue;}

private:
	int derivedValue;
}; 

DerivedClass::DerivedClass():derivedValue(10)
{
};

int main( void )
{
	BaseClass base;
	DerivedClass child;

	cout << base.baseValue0 << endl;			//  will print 20
	cout << child.baseValue0 << endl;			//  will print 20
	//  compile error
	//cout << child.baseValue1 << endl;
	cout << child.baseFunction() << endl;		//  will print 15
	cout << child.getDerivedValue() << endl;	//  will print 10

	return 0;
}