/*
 *  Classes Derivation - Single Inheritance 3.0
 *  
 *  Simple Inheritance - Protected Derivation
 */
#include <iostream>

using namespace std;

class BaseClass
{
public:
	BaseClass();
	BaseClass(int aValue);
	int baseValue;
};

BaseClass::BaseClass(): baseValue(0)
{
};


BaseClass::BaseClass(int aValue): baseValue(aValue)
{
};

class DerivedClass1 : private BaseClass
{
public:
	DerivedClass1();

	//  Access BaseClass
	int getBaseValue() {return baseValue;}
	int derivedValue1;
};

DerivedClass1::DerivedClass1():derivedValue1(10)
{
};


class DerivedClass2 : protected DerivedClass1
{
public:
	DerivedClass2();

    //  Access DerivedClass1
	int getDerivedValue1() {return derivedValue1;}

	//  Access BaseClass
	int getBaseValue2() {return getBaseValue();}

	int derivedValue2;
};

DerivedClass2::DerivedClass2():derivedValue2(20)
{
};

int main( void )
{
	BaseClass base;
	DerivedClass1 child1;
	DerivedClass2 child2;

	cout << base.baseValue << endl;				//  0

	// cout << child1.baseValue << endl;		// compile error - private
												// derivation
	cout << child1.getBaseValue() << endl;		// 0 - accessable by
												// member function only
	cout << child1.derivedValue1 << endl;		// 10 - public

	//cout << child2.baseValue << endl;			// compile error-private
												// from DC1
	//cout << child2.getBaseValue() << endl;	// compile error-protected
															// under derivation

	cout << child2.getBaseValue2() << endl;		// 0 - accessble by member
												// function only
	//cout << child2.derivedValue1 << endl;		// compile error-protected
												// under derivation

	cout << child2.getDerivedValue1() << endl;	// 10 - accessable by
												// member function only
	cout << child2.derivedValue2 << endl;		// 20 - public

	return 0;
}