/*
 *  C++ Templates - Function Templates 1.0
 *
 *   A Generic min function
 */

#include <iostream>

using namespace std;

/*
 *  Only type parameters in the function template
 *  A non-type parameter with a default value is used in the
 *  function declaration.
 */

 //	Define the function min with
 //   	one type parameter 		a
 //		one non-type parameter	b

template <class Type>

Type min(Type a, int b=2)
{return ((a<b)?a:b);}

int main( void )
{
	/*
	 *  Define some variables of different types
	 */

	int 	r=5, t;
	float 	n=4.5, p;

	// The value of the type parameter is int, the default value is overridden
	t = min(r,7);

	// The value of the type parameter is float, the default value is used
	p = min(n);

	cout << "The min values are: t = " << t << " and p = " << p << endl;
	return 0;
}

