/*
 *  C++ Templates	- Class Templates 2.0
 *
 *		A Simple Vector
 */
#include <iostream>

using namespace std;

template <class T, int n>
class Vector
{
public:
	Vector() {}					// default constructor
	Vector (T v0);				// initialize elements to v0
	T& operator [](int i);	// specify subscripting operator

	void display();

private:
	T vect[n];
};


template <class T, int n>
Vector<T,n>::Vector(T v0)
{
	//  initialize the elements of the vector

	for (int i=0; i< n; i++)
		vect[i] = v0;
}

template <class T, int n>
T& Vector<T,n>::operator [](int i)
{
	return vect[i-1];
}

template <class T, int n>
void Vector<T,n>::display()
{
	int j = (sizeof (vect))/(sizeof (T));  // determine the size of 
														//the vector

	for (int i = 0; i< j; i++)
		cout << vect[i] << " ";
	cout << endl;
	return;
}

int main( void )
{
	Vector <int,3> iv0;					// declare a vector of integers
	Vector <float, 5> fv0;     		//	declare a vector of floats
	Vector <char, 4> cv0('c');      	//	declare a vector of chars

	for (int i=1; i< 4; i++)
		iv0[i]=i;

	for (i=1; i<6; i++)
		fv0[i]= i+i/10.0;
	/*
		Execution will print
			1 2 3
			1.1 2.2 3.3 4.4 5.5
			c c c c
	*/

	iv0.display();
	fv0.display();
	cv0.display();
	return 0;
}