/*
 *	C++ Templates - Class Templates 2.2
 *
 *		Templates and Inheritance - Base and Derived Are the Same Type
 */
#include <iostream>

using namespace std;

// 	Define the Base Class
template <class T>
class BaseClass
{
public:
	BaseClass(T aValue) : myData0(aValue){};
	BaseClass() : myData0(48){};
	T myData0;
	void show() {cout << myData0 << endl;}
};

// 	Define the Derived Class - Publically inherit from Base
template <class T>
class DerivedClass : public BaseClass<T>
{
public:
	DerivedClass (T aValue) : myData(aValue){};
	DerivedClass() : myData(20){};

	T myData;
	void show() {cout << myData << myData0 << endl;}
};


int main()
{
	//  Create ca couple of class instances
	BaseClass<float> mine(15.0);
	DerivedClass <char> yours('a');
	/*
		Execution will print
			15
			a0
	*/

	mine.show();
	yours.show();

	return 0;
}

