/*
 *	C++ Templates - Class Templates 2.4
 *
 *  Add Function - Specialize for Strings - Explicit Template Function
 */

#include <iostream>
#include <string>

using namespace std;


/*
 *  Declare the template function add
 */
template <class Type> Type add(Type a, Type b) {return a+b;}

/*
 *  Specialize the add template for the string class
 */
char* add(char* aString1, char* aString2)
{
	char *data = new char [strlen (aString1)+ strlen(aString2) + 1];
	strcpy(data, aString1);
	strcat (data, aString2);
	return data;
};

/*
 *  Explicit template function
 */

double add(double a, double b) {return a+b;}


int main( void )
{
	int a = 10, b = 20;
	float c = 10.5,  d = 11.7;
	char e = 'a', f = 'b';
	char* g = "You're just ", *h = "stringing me along.";

	/*
	 *  Will print 30, 22.2, the integer sum of a and b, then
	 *  You're just stringing me along.
	 */

	cout << add(a,b) << "  "
		 << add(c, d) << "  "
		 << add(e, f)<< endl;

	cout << add(g, h) << endl;

	/*
	 *  Without the explicit template function, this would be a compile error
	 *  With the explicit template function, the float, d, is cast to a double
	 *  Will print 21.7
	 */
	cout << add(a,d) << endl;

	return 0;

}

