/*
 *	C++ Templates - Class Templates 2.5
 *
 *		Default Parameters
 */

#include <iostream>

using namespace std;


//  Define a templated class.
//  The second type parameter has a default value of int

template <class T1, class T2 = int>
class M1
{
public:
	M1(T1 aValue0, T2 aValue1) : myData(aValue0), myData0(aValue1){};
	M1(T1 aValue) : myData(aValue), myData0(10){};
	M1() : myData((T1)20), myData0((T2)3){};

	T1 myData;
	T2 myData0;
	void show() {cout << myData << "  "  << myData0 << endl;}
};

int main()
{
	//  Declare a couple of instances
	M1<float> m1(15.3f);
	M1<int, char> m2(21, 'c');

    m1.show();
	m2.show();

   /*
   Execution will print
		15.3  10
		21  	c

   */

	return 0;
}

